#include <iostream>
#include "skgrid.hpp"

using namespace std;

/* Reads a line, transforms it into the proper format. */


const std::string punct = ".-/,0x";
const std::string noise = " \t|+";

static bool transform(std::string& dst, std::string const& src)
{

	dst.clear();
	for(unsigned int i = 0 ; i < src.size() ; i++) {
		char c = src[i];
		if (c >= '1' && c <= '9') {
			dst += c;
			continue;
		}
		if (noise.find(c) != string::npos)
			continue;
		if (punct.find(c) != string::npos) {
			dst += '.';
			continue;
		}
		return false;
	}
	if (dst.size() != 9)
		return false;
	return true;
}

void print_desc(std::vector<std::string> const & desc)
{
	for(unsigned int i = 0 ; i < desc.size() ; i++) {
		if (i == 3 || i == 6)
			cout << "\n";
		for(unsigned int j = 0 ; j < 9 ; j++) {
			if (j == 3 || j == 6)
				cout << ' ';
			cout << desc[i][j];
		}
		cout << "\n";
	}
}

void input_pb(std::vector<std::string>& desc, std::istream & is)
{
	for(std::string s ; std::getline(is, s) ; ) {
		if (is.eof())
			break;
		if (s.find_first_not_of(noise) == s.npos) {
			if (desc.size() == 9)
				break;
			continue;
		}
		if (s == "b") {
			if (!desc.empty())
				desc.pop_back();
			continue;
		}
		if (s == "?") {
			print_desc(desc);
			continue;
		}
		std::string t;
		if (!transform(t, s)) {
			std::cerr << "Bad line: " << s << "\n";
			continue;
		}
		desc.push_back(t);
	}
}

